<template>
    <div class="flex items-center justify-between mb-4">
        <Breadcrumb nameRouteHome="admin" textRouteHome="Trang chủ">
            <ItemBreadcrumb isRouteLink nameRoute="teacher-course">
                Khóa học của tôi
            </ItemBreadcrumb>
            <ItemBreadcrumb>{{ course ? course.name : "" }}</ItemBreadcrumb>
        </Breadcrumb>
        <div class="flex items-center gap-3">
            <LinkButton
                nameRoute="teacher-course-update"
                :paramsRoute="{
                    name: course ? course.id : $route.params.courseId
                }"
                classCustom="bg-color-warning hover:shadow-hover-warning"
            >
                <PencilIcon class="text-white" />
                <span>Cập nhật khóa học</span>
            </LinkButton>

            <BasicButton
                v-if="course && course.status === STATUS_COURSE_DRAFT"
                @click="onSendCensorship"
                classCustom="bg-color-info hover:shadow-hover-info"
            >
                <svg
                    xmlns="http://www.w3.org/2000/svg"
                    class="text-white"
                    width="24"
                    height="24"
                    viewBox="0 0 24 24"
                    fill="none"
                    stroke="currentColor"
                    stroke-width="2"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                >
                    <line x1="22" y1="2" x2="11" y2="13"></line>
                    <polygon points="22 2 15 22 11 13 2 9 22 2"></polygon>
                </svg>
                <span>Gửi kiểm duyệt</span>
            </BasicButton>
            <BasicButton
                v-else
                classCustom="bg-color-info cursor-not-allowed"
                v-tooltip="'Khóa học này đã được kiểm duyệt'"
            >
                <svg
                    xmlns="http://www.w3.org/2000/svg"
                    class="text-white"
                    width="24"
                    height="24"
                    viewBox="0 0 24 24"
                    fill="none"
                    stroke="currentColor"
                    stroke-width="2"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                >
                    <line x1="22" y1="2" x2="11" y2="13"></line>
                    <polygon points="22 2 15 22 11 13 2 9 22 2"></polygon>
                </svg>
                <span>Gửi kiểm duyệt</span>
            </BasicButton>
        </div>
    </div>
    <div class="card">
        <div class="flex items-center">
            <a
                href="#overview"
                class="nav-item flex-initial border-r px-6 py-4"
                :class="[
                    $route.hash === '#overview'
                        ? 'text-main-color bg-white border-b-transparent'
                        : 'bg-gray-50 border-b'
                ]"
            >
                Thông tin khóa học
            </a>
            <a
                href="#lessons"
                class="nav-item flex-initial border-r px-6 py-4"
                :class="[
                    $route.hash === '#lessons'
                        ? 'text-main-color bg-white border-b-transparent'
                        : 'bg-gray-50 border-b'
                ]"
            >
                Danh sách bài học
            </a>
            <div class="flex-1 border-b cursor-default px-6 py-4">&nbsp;</div>
        </div>
        <div class="card-body">
            <div v-show="$route.hash === '#overview'">
                <OverviewCourseSkeleton v-if="isLoading" />
                <OverviewCourse v-else :course="course" />
            </div>
            <div v-show="$route.hash === '#lessons'">
                <div v-if="isLoading" class="text-center">
                    <SpinLoading />
                </div>
                <TeacherListLesson v-else :course="course" />
            </div>
        </div>
    </div>
</template>

<script>
import { useRoute } from "vue-router";
import Swal from "sweetalert2";
import { createToast } from "mosha-vue-toastify";
import { STATUS_COURSE_DRAFT } from "@/constants";

import useGetCourse from "@/hooks/course/useGetCourse";
import useUpdateStatusCompleteCourse from "@/hooks/course/useUpdateStatusCompleteCourse";

import { PencilIcon } from "@heroicons/vue/outline";
import Breadcrumb from "@/components/breadcrumb/Breadcrumb.vue";
import ItemBreadcrumb from "@/components/breadcrumb/ItemBreadcrumb.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import OverviewCourse from "@/components/course/OverviewCourse.vue";
import OverviewCourseSkeleton from "@/components/course/OverviewCourseSkeleton.vue";
import TeacherListLesson from "@/components/lesson/TeacherListLesson.vue";

export default {
    components: {
        PencilIcon,
        Breadcrumb,
        ItemBreadcrumb,
        BasicButton,
        LinkButton,
        SpinLoading,
        OverviewCourse,
        OverviewCourseSkeleton,
        TeacherListLesson
    },
    setup() {
        const route = useRoute();
        const { isLoading, course, onGetCourse } = useGetCourse();
        const {
            errorResponseUpdate,
            onUpdateStatusCompleteCourse
        } = useUpdateStatusCompleteCourse();

        async function getCourse() {
            await onGetCourse(route.params.courseId);
        }
        getCourse();

        function onSendCensorship() {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn muốn gửi kiểm duyệt khóa học này tới Quản trị viên</span>`,
                confirmButtonText: "Gửi",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    await onUpdateStatusCompleteCourse(route.params.courseId);
                    if (errorResponseUpdate.value) {
                        createToast("Đã có lỗi xảy ra, vui lòng thử lại sau", {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        createToast("Gửi thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        return { STATUS_COURSE_DRAFT, isLoading, course, onSendCensorship };
    }
};
</script>
